<?php
/*
//		link_popularity.php
//		LinkPopularity - skrypt do sprawdzania IP i BL w serwisach Google, MSN, Yahoo!
//		IP - Indexed Pages BL - Back Links
//
//		Copyright (C) 2006 Yuriy Hatala (yuriy@myth.org.ua)
//
*/

/*		
//		Skrypt jest udostepniany za darmo,
//		ale bedze mi milo jezeli umiescisz na swojej stronie link
//		----------------------------------------------------------------------
//		<a href="http://zakladka.org.ua" target="_blank">Katalog Ukrai?skich Stron</a>
//
//		lub kod Google AdSense
/*
		<script type="text/javascript"><!--
		google_ad_client = "pub-1115211806019693";
		google_ad_channel ="8871513117";
		google_ad_width = 234;
		google_ad_height = 60;
		google_ad_format = "234x60_as";
		google_ad_type = "text_image";
		//--></script>
		<script type="text/javascript"
  			src="http://pagead2.googlesyndication.com/pagead/show_ads.js">
		</script>
/*

/*
//		INSTALACJA
//		----------------------------------------------------------------------
//		1. 	Sworzyc na serwerze katalog "lp_cache" z prawami do zapisu
//		2. 	W tym katalogu stworzyc plik ".htaccess" 
//		2.1	zapisac do pliku ".htaccess" :
//				<limit POST GET>
//				deny from all
//				</limit>
//		3.	Skopijowac plik "link_popularity.php" na serwer
//		----------------------------------------------------------------------
//
//      JAK KORZYSTAC ZE SKRYPTU
//      ----------------------------------------------------------------------
//		dane o LinkPopularity sa przechowywany w plikach i sa wazne przez 24 godziny,
//		po uplywie tego czasu przy ponownym wywolaniu skryptu dane zostana zaktualizowane.
//		zeby zmienic czas waznosci danych (czas keszowania) wystarczy zmienic wartosc zmiennej CACHE_TIME.
//		Czas jest podawany w sekundach ( 86400 sec. = 24 godziny )
//	
//		define("CACHE_TIME", 86400);
//	
//		<?php 
//			include("link_popularity.php");

//			// $website - tu podac URL strony, dla ktorej chcesz sprawdzic LinkPopularity
//			$website = "http://zakladka.org.ua";
//			$lp_test = LinkPopularity($website);
//
//			echo "Google IP : ".$lp_test['Google']['ip'];
//			echo "Google BL : ".$lp_test['Google']['bl'];
//
//			echo "MSN IP : ".$lp_test['MSN']['ip'];
//			echo "MSN BL : ".$lp_test['MSN']['bl'];
//
//			echo "Yahoo! IP : ".$lp_test['Yahoo!']['ip'];
//			echo "Yahoo! BL : ".$lp_test['Yahoo!']['bl'];
//		?>
*/

 define("CACHE_DIR", "./lp_cache");
 define("CACHE_TIME", 86400);	

 function LinkPopularity($website)
 {
	$Result = array();	
	if (preg_match("/^(https?:\/\/)?([^\/]+)/i", $website, $matches)) { $target = $matches[2]; }
	
	if (strlen(trim(CACHE_DIR)) > 0)
	{
		$file = sprintf("%s/lp_%s", CACHE_DIR, md5($target));
		if (file_exists($file) && (filesize($file) > 0) && (time() - filemtime($file)) < CACHE_TIME)
		 { $Result = unserialize(join('', file($file))); }
		else
		{
			if ($handle = @fopen($file, "w"))
			{
				if (is_resource($handle) && flock($handle, LOCK_EX))
				{
					$Result  = getData($target);
					$sResult = serialize($Result);
					fwrite($handle, $sResult, strlen($sResult));
					flock($handle, LOCK_UN);
				}
				fclose($handle);				
			}
		}
	}
	else { $Result = getData($target); }
	return $Result;
 }

 function getData($target)
 {
	$Result = array();
	$DataArray = array('Google' => array('Mask' => "/about\s+(\d+(,\d+)*)\s+(linking|from)/",
										 'BLSearch' => "http://www.google.com/search?hl=en&lr=&ie=UTF-8&q=link%3A!TARGET_HOST!",
										 'IPSearch' => "http://www.google.com/search?hl=en&lr=&sa=G&q=site%3A!TARGET_HOST!"),
					   'Yahoo!' => array('Mask' => "/of about\s+(\d+(,\d+)*)\s+(-|for)/",
'BLSearch' => "http://siteexplorer.search.yahoo.com/search?p=http%3A%2F%2F!TARGET_HOST!&bwm=i&bwmf=s&bwmo=&fr=FP-tab-web-t&fr2=seo-rd-se",
'IPSearch' => "http://siteexplorer.search.yahoo.com/search?p=!TARGET_HOST!&sm=Yahoo%21+Search&fr=FP-tab-web-t&toggle=1"),

					   'MSN'    => array('Mask' => "/of\s+(\d+(,\d+)*)\s+result/",
										 'BLSearch' => "http://search.msn.com/results.aspx?q=link%3A!TARGET_HOST!",
										 'IPSearch' => "http://search.msn.com/results.aspx?q=site%3A!TARGET_HOST!&first=1&FORM=PDRE")
					 );
										 
	foreach ($DataArray as $Service => $Data)
	{
		$Result[$Service]['bl'] = fetchBySocket(preg_replace("/\!TARGET_HOST\!/", $target, $Data['BLSearch']), $Data['Mask']);
		$Result[$Service]['ip'] = fetchBySocket(preg_replace("/\!TARGET_HOST\!/", $target, $Data['IPSearch']), $Data['Mask']);
	}
	return $Result;
 }
 
 function fetchBySocket($source, $mask, $strip_tag = TRUE)
 {
 	$flReturn = false;
	if (($Socket = socket_create(AF_INET, SOCK_STREAM, 0)) > 0) 
	{
		$tmpParam = parse_url($source);
		$SendHeader = "GET ".$tmpParam[path]."?".$tmpParam[query]." HTTP/1.0\r\n".
					  "Referer: http://zakladka.org.ua\r\n".
					  "Host: ".$tmpParam['host']."\r\n".
					  "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)\r\n\r\n";
		
		if (socket_connect($Socket, gethostbyname($tmpParam[host]), getservbyname ('www', 'tcp')) > 0)
		{
			socket_write($Socket, $SendHeader, strlen($SendHeader));
			while ($ReadContent = socket_read($Socket, 1024))
			{
				if ($strip_tag) { $tmpContent .= strip_tags($ReadContent); }
				else { $tmpContent .= $ReadContent; }
				if (preg_match($mask, $tmpContent, $Result)) { $flReturn = true; break; }
			}
		}
		socket_close($Socket);
		if ($flReturn) { return $Result[1]; } else { return 0; }
	}
	else { return 0; }
 }	
 
?>
